<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <!-- 主表单区域 -->
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="12" >
            <a-form-item label="Contact Name" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['contactName']" placeholder="请输入Contact Name"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="Date" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择Date" v-decorator="['createTime']" :trigger-change="true" style="width: 100%"/>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="Phone No." :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['phoneNo']" placeholder="请输入Phone No."></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="Reference" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['reference']" placeholder="请输入Reference"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="Company" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['company']" placeholder="请输入Company"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="Address" :labelCol="labelCol2" :wrapperCol="wrapperCol2">
              <a-textarea v-decorator="['address']" rows="4" placeholder="请输入Address"/>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
      <!-- 子表单区域 -->
    <a-tabs v-model="activeKey" @change="handleChangeTabs">
      <a-tab-pane tab="delivery_note_list" :key="refKeys[0]" :forceRender="true">
        <j-editable-table
          :ref="refKeys[0]"
          :loading="iostDeliveryNoteListTable.loading"
          :columns="iostDeliveryNoteListTable.columns"
          :dataSource="iostDeliveryNoteListTable.dataSource"
          :disabled="formDisabled"
          :rowNumber="true"
          :rowSelection="true"
          :actionButton="true"/>
      </a-tab-pane>
    </a-tabs>
  </a-spin>
</template>

<script>

  import pick from 'lodash.pick'
  import { getAction } from '@/api/manage'
  import { FormTypes,getRefPromise } from '@/utils/JEditableTableUtil'
  import { JEditableTableMixin } from '@/mixins/JEditableTableMixin'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'
  import JDate from '@/components/jeecg/JDate'  

  export default {
    name: 'IostDeliveryNoteForm',
    mixins: [JEditableTableMixin],
    components: {
      JFormContainer,
      JDate,
    },
    data() {
      return {
        labelCol: {
          xs: { span: 24 },
          sm: { span: 6 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        labelCol2: {
          xs: { span: 24 },
          sm: { span: 3 },
        },
        wrapperCol2: {
          xs: { span: 24 },
          sm: { span: 20 },
        },
        // 新增时子表默认添加几行空数据
        addDefaultRowNum: 1,
        validatorRules: {
        },
        refKeys: ['iostDeliveryNoteList', ],
        tableKeys:['iostDeliveryNoteList', ],
        activeKey: 'iostDeliveryNoteList',
        // delivery_note_list
        iostDeliveryNoteListTable: {
          loading: false,
          dataSource: [],
          columns: [
            {
              title: 'Description',
              key: 'description',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'CTNS',
              key: 'ctns',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'Length(cm)',
              key: 'length',
              type: FormTypes.inputNumber,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'Width(cm)',
              key: 'width',
              type: FormTypes.inputNumber,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'Height(cm)',
              key: 'height',
              type: FormTypes.inputNumber,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'CBM',
              key: 'cbm',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'Weight(kg)',
              key: 'weight',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: 'MARK',
              key: 'mark',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
          ]
        },
        url: {
          add: "/basedata/iostDeliveryNote/add",
          edit: "/basedata/iostDeliveryNote/edit",
          queryById: "/basedata/iostDeliveryNote/queryById",
          iostDeliveryNoteList: {
            list: '/basedata/iostDeliveryNote/queryIostDeliveryNoteListByMainId'
          },
        }
      }
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：false流程表单 true普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      addBefore(){
        this.form.resetFields()
        this.iostDeliveryNoteListTable.dataSource=[]
      },
      getAllTable() {
        let values = this.tableKeys.map(key => getRefPromise(this, key))
        return Promise.all(values)
      },
      /** 调用完edit()方法之后会自动调用此方法 */
      editAfter() {
        let fieldval = pick(this.model,'contactName','createTime','phoneNo','reference','company','address')
        this.$nextTick(() => {
          this.form.setFieldsValue(fieldval)
        })
        // 加载子表数据
        if (this.model.id) {
          let params = { id: this.model.id }
          this.requestSubTableData(this.url.iostDeliveryNoteList.list, params, this.iostDeliveryNoteListTable)
        }
      },
      /** 整理成formData */
      classifyIntoFormData(allValues) {
        let main = Object.assign(this.model, allValues.formValue)
        return {
          ...main, // 展开
          iostDeliveryNoteListList: allValues.tablesValue[0].values,
        }
      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          })
        }
      },
      validateError(msg){
        this.$message.error(msg)
      },
     popupCallback(row){
       this.form.setFieldsValue(pick(row,'contactName','createTime','phoneNo','reference','company','address'))
     },

    }
  }
</script>

<style scoped>
</style>